Index: algorithms.py
===================================================================
--- algorithms.py	(revision e40e335d8909b50cd784019735fcdb0c28ee19bb)
+++ algorithms.py	(revision e40e335d8909b50cd784019735fcdb0c28ee19bb)
@@ -0,0 +1,91 @@
+# algorithms.py
+#
+# Copyright 2007       Frank Eisenmenger, U.H.E. Hansmann,
+#                      Jan H. Meinke, Sandipan Mohanty
+#
+import copy
+import random
+import smmp
+from math import *
+from universe import *
+from protein import *
+
+class CanonicalMonteCarlo:
+    """An implementation of a canonical Monte Carlo run using Metropolis weights.
+    After a Monte-Carlo sweep over all internal variables, this implementation 
+    calculates the interactions between all Protein s in the Universe
+    """
+    
+    def __init__(self, myUniverse, nequi, sweeps, weight =  lambda x : x * smmp.bet.beta):
+        self.__defSweeps = sweeps
+        self.__defEqui = nequi
+        self.__univ = myUniverse
+        self.__acc = 0
+        self.__performedSweeps = 0
+        self.__minEnergy = myUniverse.energy()
+        self.__l = 0.1
+        self.__minCounter = 0
+        self.__weight = weight
+        
+    ## Fraction of accepted Monte Carlo moves of the total number of attempted moves.
+    #  @pre At least one move must have been performed before this function can be
+    #       called
+    #  @return fraction of accepted moves as a number between 0 and 1.
+    def acceptanceRate(self):
+        return float(self.__acc) / (self.__performedSweeps * smmp.mol_par.nvr)
+    ## The lowest energy ever seen at the end of a Monte Carlo move.
+    #  @return lowest energy seen at the end of a sweep, sweep
+    def minimumEnergy(self):
+        return self.__minEnergy, self.__minCounter
+    ## Number of sweeps performed so far
+    def performedSweeps(self):
+        return self.__performedSweeps
+        
+    def run(self):
+        """A complete Monte Carlo run including initial equilibration."""
+        self.sweeps(self.__defSweeps)
+        
+    def equilibrate(self):
+        """Do nequi sweeps to eqilibrate the system."""
+        self.sweeps(self.__defEqui)
+        
+    def sweeps(self, n):
+        """Perform n sweeps."""
+        for i in range(0, n):
+            self.sweep()
+        
+    def sweep(self):
+        """Performs a single Monte Carlo sweep."""
+        eol = self.__univ.energy()
+        eol, self.__acc = smmp.metropolis(eol, self.__acc, self.__weight)
+        #eol = self.metropolis()
+        self.__performedSweeps += 1
+        if eol < self.__minEnergy:
+            self.__minEnergy = eol
+            self.__minCounter = self.__performedSweeps
+            smmp.outpdb(0, "best.pdb")
+
+    def metropolis(self):
+        """Implementation of the Metropolis algorithm."""
+        eol = self.__univ.energy()
+        # Update the internal degrees of freedom first
+        for i in range(0, smmp.mol_par.nvr):
+            jv = smmp.var_i.idvr[i] - 1
+            vrol = smmp.var_r.vlvr[jv]
+            dv=smmp.var_r.axvr[jv] * (random.random() - 0.5)
+            smmp.var_r.vlvr[jv] = (vrol + dv + pi) % (2 * pi) - pi
+            etrial = self.__univ.energy()
+            dW = self.__weight(etrial) - self.__weight(eol)
+            if dW < 0:
+                eol = etrial
+                self.__acc += 1
+            else:
+                rd =random.random()
+                dW = min(dW, 100)
+                if  exp(-dW) > rd:
+                    eol = etrial
+                    self.__acc +=1
+                else:
+                    smmp.var_r.vlvr[jv] = vrol
+        # Update the global degrees of freedom
+        return eol
Index: anneal.f
===================================================================
--- anneal.f	(revision 87ddcf7a314d90070d607f0ec7ac0a700b843abc)
+++ anneal.f	(revision e40e335d8909b50cd784019735fcdb0c28ee19bb)
@@ -1,65 +1,59 @@
-! **************************************************************
-!
-! This file contains the subroutines:  anneal
-!
-! Copyright 2003-2005  Frank Eisenmenger, U.H.E. Hansmann,
-!                      Shura Hayryan, Chin-Ku 
-! Copyright 2007       Frank Eisenmenger, U.H.E. Hansmann,
-!                      Jan H. Meinke, Sandipan Mohanty
-!
-! $Id: anneal.f 334 2007-08-07 09:23:59Z meinke $
-! **************************************************************
+c **************************************************************
+c
+c This file contains the subroutines:  anneal
+c
+c Copyright 2003-2005  Frank Eisenmenger, U.H.E. Hansmann,
+c                      Shura Hayryan, Chin-Ku 
+c Copyright 2007       Frank Eisenmenger, U.H.E. Hansmann,
+c                      Jan H. Meinke, Sandipan Mohanty
+c
+c $Id: anneal.f 334 2007-08-07 09:23:59Z meinke $
+c **************************************************************
 
       subroutine  anneal(nequi, nswp, nmes, tmax, tmin, lrand)
 
-! --------------------------------------------------------------
-! PURPOSE: SIMULATED ANNEALING SEARCH OF LOWEST-POTENTIAL-ENERGY
-!          CONFORMATIONS OF PROTEINS
-!
-! CALLS: addang,energy,metropolis,outvar,outpdb,rgyr,setvar,zimmer
-!
-! ---------------------------------------------------------------
+C --------------------------------------------------------------
+C PURPOSE: SIMULATED ANNEALING SEARCH OF LOWEST-POTENTIAL-ENERGY
+C          CONFORMATIONS OF PROTEINS
+C
+C CALLS: addang,energy,metropolis,outvar,outpdb,rgyr,setvar,zimmer
+C
+C ---------------------------------------------------------------
  
       include 'INCL.H'
 
-!f2py intent(in) nequi
-!f2py intent(in) nswp
-!f2py intent(in) nmes
-!f2py intent(in) Tmax
-!f2py intent(in) Tmin
-!f2py logical optional, intent(in):: lrand = 1
+cf2py intent(in) nequi
+cf2py intent(in) nswp
+cf2py intent(in) nmes
+cf2py intent(in) Tmax
+cf2py intent(in) Tmin
+cf2py logical optional, intent(in):: lrand = 1
 
-!     external rand
+c     external rand
       external can_weight
-      
-      double precision bmin, bmax, db, dv, grnd, vr, addang, eol, energy
-      double precision acz, ymin, vlvrm, rgy, ee, temp
-
-      integer nresi, i, iv, nsw, nemin, j
-      
-!      parameter(lrand=.true.)
-!      parameter(nequi=100, nswp=100000,nmes=1000)
-!      parameter(tmax=1000.0,tmin=100.0)
-!     lrand=.true.: creates random start configuration 
+c      parameter(lrand=.true.)
+c      parameter(nequi=100, nswp=100000,nmes=1000)
+c      parameter(tmax=1000.0,tmin=100.0)
+C     lrand=.true.: creates random start configuration 
       logical lrand
-!     nequi: Number of sweeps for equilibrisation of system
+C     nequi: Number of sweeps for equilibrisation of system
       integer nequi
-!     nswp:  Number of sweeps for simulation run
+C     nswp:  Number of sweeps for simulation run
       integer nswp
-!     nmes:  Number of sweeps between measurments
+c     nmes:  Number of sweeps between measurments
       integer nmes
-!     tmax: Start temperature
+C     tmax: Start temperature
       double precision tmax
-!     tmin: Final temperature
+C     tmin: Final temperature
       double precision tmin
      
       
 !      common/bet/beta
-!
+C
       dimension vlvrm(mxvr)
 
      
  
-!     Define files for output:
+c     Define files for output:
       open(14,file='time.d')
       write(14, *) '# $Id: anneal.f 334 2007-08-07 09:23:59Z meinke $'
@@ -70,8 +64,8 @@
       db = exp(log(bmax/bmin)/nswp)
 
-!     nresi: Number of residues
-! FIXME: Should loop over all proteins
+c     nresi: Number of residues
+c FIXME: Should loop over all proteins
       nresi=irsml2(ntlml)-irsml1(1)+1
-! _________________________________ random start
+c _________________________________ random start
       if(lrand) then
        do i=1,nvr
@@ -84,19 +78,17 @@
 
       eol=energy()
-      write (logString, '(a,e12.5,/)')  
-     &   'energy of start configuration: ',eol
+      write (*,'(a,e12.5,/)')  'energy of start configuration: ',eol
 
-! Write start configuration in pdb-format into file
+C Write start configuration in pdb-format into file
         call outpdb(0, "start.pdb")
 
-! =====================Equilibration by  Metropolis
+c =====================Equilibration by  Metropolis
       beta =  bmin
       do nsw=1,nequi
          call metropolis(eol,acz,can_weight)
       end do
-      write (logString, *) 
-     &   'Energy after  equilibration:', eol
+      write(*,*) 'Energy after  equilibration:',eol
 
-!======================Simulation by simulated annealing
+C======================Simulation by simulated annealing
       acz = 0.0d0
       ymin = eol
@@ -104,10 +96,10 @@
         beta = bmin*db**nsw
         call metropolis(eol,acz,can_weight)
-! Store lowest-energy conformation
+c Store lowest-energy conformation
         if(eol.lt.ymin) then
          ymin = eol
          nemin = nsw
          call outvar(0,'global.var')
-!     Output of lowest-energy conformation as pdb-file
+C     Output of lowest-energy conformation as pdb-file
          call outpdb(0,"global.pdb")
          do j=1,nvr
@@ -116,11 +108,11 @@
          end do
         end if
-!
+c
         if(mod(nsw,nmes).eq.0) then
-! Measure radius of gyration and end-to-end distance
+C Measure radius of gyration and end-to-end distance
          call rgyr(1, rgy, ee)
-! Determine Zimmerman code of actual conformation
+C Determine Zimmerman code of actual conformation
          call zimmer(nresi)
-! Write down information on actual conformation
+C Write down information on actual conformation
          temp =  1.0d0/beta/0.00198773
          write(14,'(i6,13f12.3,1x,a)')  
@@ -129,21 +121,21 @@
      &   eyhb, eyvw, eyel, eyvr, zimm(1:nresi)
         end if
-!
+C
       end do
 
       acz = acz/dble(nsw*nvr)
-      write (logString, *) 'acceptance rate:',acz
-      write (logString, *)
-! ------------ Output Dihedreals of final configuration
-      write (logString, *) 'last energy',eol
+      write(*,*) 'acceptance rate:',acz
+      write(*,*)
+c ------------ Output Dihedreals of final configuration
+      write(*,*) 'last energy',eol
       call outvar(0,' ')
-!     Output final conformation as pdb-file
+C     Output final conformation as pdb-file
       call outpdb(0,"final.pdb")
-      write (logString, *)
+      write(*,*)
 
-! ------------ Output Dihedreals of conformation with lowest energy
-      write (logString, *) 'lowest energy ever found:',nemin,ymin
+c ------------ Output Dihedreals of conformation with lowest energy
+      write(*,*) 'lowest energy ever found:',nemin,ymin
       close(14)
-! =====================
+c =====================
 
 
Index: bgs.f
===================================================================
--- bgs.f	(revision 87ddcf7a314d90070d607f0ec7ac0a700b843abc)
+++ bgs.f	(revision e40e335d8909b50cd784019735fcdb0c28ee19bb)
@@ -2,5 +2,5 @@
 ! Trial version implementing the semi-local conformational update
 ! BGS (Biased Gaussian Steps). This file presently contains the
-! functions initlund, bgsposs and bgs.
+! functions initlund, bgsposs and bgs. 
 !
 ! Copyright 2007       Frank Eisenmenger, U.H.E. Hansmann,
@@ -8,12 +8,66 @@
 ! ****************************************************************
 
-
-! Checks if it is possible to perform a BGS update starting at the
+! Subroutine initlund: Initializes data structures used frequently 
+! in connection with Biased Gaussian Steps and the energy functions
+! from Anders Irback's protein folding model. Calls: none.
+!
+      subroutine init_lund
+      include 'INCL.H'
+      include 'incl_lund.h'
+      logical bgsposs
+      do i=1,mxrs
+         iN(i)=-1
+         iCa(i)=-1
+         iC(i)=-1
+         iphi(i)=-34
+         ipsi(i)=-35
+      enddo
+!      print *,'total number of variables = ',nvr
+
+      do i=1,ntlml
+         npprs=1
+         do j=ivrml1(i),ivrml1(i)+nvrml(i)-1
+            mlvr(j)=i
+            if (nmvr(j).eq.'phi') then 
+               iphi(npprs)=j
+! Now if the residue is a proline, there is no phi angle in the variable
+! list in SMMP, and so iphi(j) will remain at the initial value. 
+! So, make sure you never use iphi(i) for proline. 
+            endif
+            if (nmvr(j).eq.'psi'.or.nmvr(j).eq.'pst') then 
+               ipsi(npprs)=j
+               npprs=npprs+1
+            endif
+         enddo
+         do j=irsml1(i),irsml2(i)
+            iN(j)=iatrs1(j) 
+            do k=iatrs1(j),iatrs2(j)
+               if (nmat(k)(1:2).eq.'ca') then 
+                  iCa(j)=k 
+               endif
+               if (nmat(k)(1:1).eq.'c') then 
+                  iC(j)=k 
+               endif 
+            enddo
+!            print *,'determined phi,psi serial for residue',j,' as '
+!     #           ,iphi(j),ipsi(j)
+         enddo
+      enddo
+      abgs=300.0
+      bbgs=10.0
+      bgsnvar=0
+      do i=1,nvr
+         if (bgsposs(i)) then
+            bgsnvar=bgsnvar+1
+            bgsvar(bgsnvar)=i
+         endif
+      enddo
+      end
+
+! Checks if it is possible to perform a BGS update starting at the 
 ! variable indexed ipos. Calls: none.
       logical function bgsposs(ips)
       include 'INCL.H'
       include 'incl_lund.h'
-      integer jv, ips, iaa, nursvr, nnonfx, i
-
       logical ians
 
@@ -22,20 +76,20 @@
       ians=.true.
 !      print *,'evaluating bgs possibility for ',ips,nmvr(jv)
-      if (nmvr(jv).ne.'phi') then
+      if (nmvr(jv).ne.'phi') then 
 !         print *,'bgs not possible because variable name is ',nmvr(jv)
          ians=.false.
-      else if (iaa.gt.(irsml2(mlvr(jv))-3)) then
+      else if (iaa.gt.(irsml2(mlvr(jv))-3)) then 
 !         print *,'bgs impossible, residue too close to end'
 !         print *,'iaa = ',iaa,' end = ',irsml2(mlvr(jv))
          ians=.false.
-      else
-         nnonfx=0
+      else 
+         nnonfx=0 
          do i=iaa,iaa+3
-            if (iphi(i).gt.0) then
+            if (iphi(i).gt.0) then 
                if (.not.fxvr(iphi(i))) then
                   nnonfx=nnonfx+1
                endif
             endif
-            if (.not.fxvr(ipsi(i))) then
+            if (.not.fxvr(ipsi(i))) then 
                nnonfx=nnonfx+1
             endif
@@ -54,15 +108,15 @@
 
 ! Biased Gaussian Steps. Implements a semi-local conformational update
-! which modifies the protein backbone locally in a certain range of
-! amino acids. The 'down-stream' parts of the molecule outside the
+! which modifies the protein backbone locally in a certain range of 
+! amino acids. The 'down-stream' parts of the molecule outside the 
 ! region of update get small rigid body translations and rotations.
 !
-! Use the update sparingly. It is rather local, and is not of great
+! Use the update sparingly. It is rather local, and is not of great 
 ! value if we need big changes in the conformation. It is recommended
-! that this update be used to refine a structure around a low energy
+! that this update be used to refine a structure around a low energy 
 ! candidate structure. Even at low energies, if you always
-! perform BGS, the chances of coming out of that minimum are small.
-! So, there is a probability bgsprob, which decides whether BGS or the
-! normal single angle update is used.
+! perform BGS, the chances of coming out of that minimum are small. 
+! So, there is a probability bgsprob, which decides whether BGS or the 
+! normal single angle update is used. 
 !
 ! Calls: energy, dummy (function provided as argument), addang, (rand)
@@ -72,10 +126,4 @@
       include 'INCL.H'
       include 'incl_lund.h'
-      double precision grnd, xiv, bv, ab, rv, dv, a, sum, p, r1, r2
-      double precision ppsi, wfw, addang, enw, energy, wbw, rd, delta
-      double precision dummy, eol1
-
-      integer ivar, i, nph, jv, ia, nursvr, icurraa, j, k, l
-
       external dummy
       dimension xiv(8,3),bv(8,3),rv(3,3),dv(3,8,3)
@@ -84,5 +132,5 @@
 ! Initialize
 !      print *,'using BGS on angle ',nmvr(idvr(ivar))
-      if (bgsnvar.eq.0) then
+      if (bgsnvar.eq.0) then 
          bgs=0
          goto 171
@@ -99,5 +147,5 @@
       do i=1,4
          icurraa=ia+i-1
-         if (iphi(icurraa).gt.0.and..not.fxvr(iphi(icurraa))) then
+         if (iphi(icurraa).gt.0.and..not.fxvr(iphi(icurraa))) then 
             nph=nph+1
             xiv(nph,1)=xat(iCa(icurraa))
@@ -108,7 +156,7 @@
             bv(nph,3)=xiv(nph,3)-zat(iN(icurraa))
             ab(nph)=bv(nph,1)*bv(nph,1)+bv(nph,2)*bv(nph,2)
-     &           +bv(nph,3)*bv(nph,3)
+     #           +bv(nph,3)*bv(nph,3)
             iph(nph)=iphi(icurraa)
-         endif
+         endif 
          if (.not.fxvr(ipsi(icurraa))) then
             nph=nph+1
@@ -120,5 +168,5 @@
             bv(nph,3)=xiv(nph,3)-zat(iCa(icurraa))
             ab(nph)=bv(nph,1)*bv(nph,1)+bv(nph,2)*bv(nph,2)
-     &           +bv(nph,3)*bv(nph,3)
+     #           +bv(nph,3)*bv(nph,3)
             iph(nph)=ipsi(icurraa)
          endif
@@ -137,12 +185,12 @@
          do j=1,nph
             dv(i,j,1)=(1.0/ab(j))*(bv(j,2)*(rv(i,3)-xiv(j,3))-
-     &           bv(j,3)*(rv(i,2)-xiv(j,2)))
+     c           bv(j,3)*(rv(i,2)-xiv(j,2)))
             dv(i,j,2)=(-1.0/ab(j))*(bv(j,1)*(rv(i,3)-xiv(j,3))-
-     &           bv(j,3)*(rv(i,1)-xiv(j,1)))
+     c           bv(j,3)*(rv(i,1)-xiv(j,1)))
             dv(i,j,3)=(1.0/ab(j))*(bv(j,1)*(rv(i,2)-xiv(j,2))-
-     &           bv(j,2)*(rv(i,1)-xiv(j,1)))
-         enddo
-      enddo
-      do i=1,nph
+     c           bv(j,2)*(rv(i,1)-xiv(j,1)))
+         enddo
+      enddo
+      do i=1,nph 
          do j=i,nph
             A(i,j)=0
@@ -165,7 +213,7 @@
                sum=sum-A(i,k)*A(j,k)
             enddo
-            if (i.eq.j) then
-               p(i)=sqrt(sum)
-            else
+            if (i.eq.j) then 
+               p(i)=sqrt(sum) 
+            else 
                A(j,i)=sum/p(i)
             endif
@@ -185,5 +233,5 @@
          dph(i)=0
       enddo
-! Solve lower triangular matrix to get dphi proposals
+! Solve lower triangular matrix to get dphi proposals 
       do i=nph,1,-1
          sum=ppsi(i)
@@ -198,5 +246,5 @@
       do i=1,nph
          sum=sum+ppsi(i)*ppsi(i)
-      enddo
+      enddo 
       wfw=exp(-sum)
       do i=1,nph
@@ -216,5 +264,5 @@
       do i=1,4
          icurraa=ia+i-1
-         if (iphi(icurraa).gt.0.and..not.fxvr(iphi(icurraa))) then
+         if (iphi(icurraa).gt.0.and..not.fxvr(iphi(icurraa))) then 
             nph=nph+1
             xiv(nph,1)=xat(iCa(icurraa))
@@ -225,8 +273,8 @@
             bv(nph,3)=xiv(nph,3)-zat(iN(icurraa))
             ab(nph)=bv(nph,1)*bv(nph,1)+bv(nph,2)*bv(nph,2)
-     &           +bv(nph,3)*bv(nph,3)
+     #           +bv(nph,3)*bv(nph,3)
             iph(nph)=iphi(icurraa)
-         endif
-         if (.not.fxvr(ipsi(icurraa))) then
+         endif 
+         if (.not.fxvr(ipsi(icurraa))) then 
             nph=nph+1
             xiv(nph,1)=xat(iC(icurraa))
@@ -237,5 +285,5 @@
             bv(nph,3)=xiv(nph,3)-zat(iCa(icurraa))
             ab(nph)=bv(nph,1)*bv(nph,1)+bv(nph,2)*bv(nph,2)
-     &           +bv(nph,3)*bv(nph,3)
+     #           +bv(nph,3)*bv(nph,3)
             iph(nph)=ipsi(icurraa)
          endif
@@ -254,12 +302,12 @@
          do j=1,nph
             dv(i,j,1)=(1.0/ab(j))*(bv(j,2)*(rv(i,3)-xiv(j,3))-
-     &           bv(j,3)*(rv(i,2)-xiv(j,2)))
+     c           bv(j,3)*(rv(i,2)-xiv(j,2)))
             dv(i,j,2)=(-1.0/ab(j))*(bv(j,1)*(rv(i,3)-xiv(j,3))-
-     &           bv(j,3)*(rv(i,1)-xiv(j,1)))
+     c           bv(j,3)*(rv(i,1)-xiv(j,1)))
             dv(i,j,3)=(1.0/ab(j))*(bv(j,1)*(rv(i,2)-xiv(j,2))-
-     &           bv(j,2)*(rv(i,1)-xiv(j,1)))
-         enddo
-      enddo
-      do i=1,nph
+     c           bv(j,2)*(rv(i,1)-xiv(j,1)))
+         enddo
+      enddo
+      do i=1,nph 
          do j=i,nph
             A(i,j)=0
@@ -270,5 +318,5 @@
             enddo
             A(i,j)=bbgs*A(i,j)
-            if (i.eq.j) then
+            if (i.eq.j) then 
                A(i,j)=A(i,j)+1
             endif
@@ -282,7 +330,7 @@
                sum=sum-A(i,k)*A(j,k)
             enddo
-            if (i.eq.j) then
-               p(i)=sqrt(sum)
-            else
+            if (i.eq.j) then 
+               p(i)=sqrt(sum) 
+            else 
                A(j,i)=sum/p(i)
             endif
@@ -293,5 +341,5 @@
          do j=i+1,nph
             ppsi(i)=ppsi(i)+A(j,i)*dph(j)
-         enddo
+         enddo  
       enddo
       sum=0
@@ -299,5 +347,5 @@
          sum=sum+ppsi(i)*ppsi(i)
       enddo
-      wbw=exp(-sum)
+      wbw=exp(-sum) 
       do i=1,nph
          wbw=wbw*p(i)
@@ -314,20 +362,20 @@
 !       call outpdb(0,'after.pdb')
 !      print *,'after outpdb for after.pdb'
-!      do i=1,nph
+!      do i=1,nph 
 !         print *,'BGS>',i,iph(i),vlvr(iph(i)),dph(i)
 !      enddo
-      if (rd.ge.delta) then
+      if (rd.ge.delta) then 
 !     accept
          eol1=enw
          bgs=1
 !         print *,'BGS move accepted'
-      else
+      else 
 !     reject
          vlvr = ovr
 !          enw=energy()
 !          if (abs(enw-eol1).gt.0.000001) then
-!             write (logString, *) 'rejected bgs move: energy change :',eol1,enw
+!             write(*,*) 'rejected bgs move: energy change :',eol1,enw
 !          endif
-!         write (logString, *) 'rejected bgs move: ',eol1,enw,wfw,wbw,rd
+!         write(*,*) 'rejected bgs move: ',eol1,enw,wfw,wbw,rd
          bgs=0
       endif
